; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

; ====================================

comment * ----------------------------------------------------
        The following macro system for a string comparison
        switch block was designed by Michael Webster. It has
        been slightly modified for case INSENSITIVE comparison.
        ----------------------------------------------------- *

; 
; Macros for storing and retrieving text macros, based on
; the $casstk code from Greg Falen's Switch/Case macros.
; 

    $text_stack$ equ <#>

    pushtext MACRO name:req
        $text_stack$ CATSTR <name>, <#>, $text_stack$
    ENDM

    poptext MACRO name:req
        LOCAL pos
        pos INSTR $text_stack$, <#>
        name SUBSTR $text_stack$, 1, pos-1
        $text_stack$ SUBSTR $text_stack$, pos+1
    ENDM

; 
; Macros to implement a string-comparison specific
; Switch/Case construct. Multiple instances and
; nesting supported.
; 

    $test_val$ equ <>
    $end_sw$ equ <>
    $sw_state$ equ <>
    _sw_cnt_ = 0

    switchi$ MACRO lpstring:REQ
        pushtext $test_val$                 ;; Preserve globals for previous Switch/Case.
        pushtext $sw_state$
        pushtext $end_sw$

        $test_val$ equ <lpstring>           ;; Copy string address for this Select/Case
                                            ;; to global so case$ can access it.             
        $sw_state$ equ <>                   ;; Set state global to starting value.
        _sw_cnt_ = _sw_cnt_ + 1             ;; Generate a unique exit label for this
        $end_sw$ CATSTR <end_sw>, %_sw_cnt_ ;; Select/Case and preserve it.
        pushtext $end_sw$
    ENDM

    casei$ MACRO quoted_text:REQ
        ;; The case statements will be any statements between the case$ and the following case$,
        ;; else$, or endsw$.
        ;;
        ;; If this is a following case$, emit a jump to the exit label for this Select/Case and
        ;; terminate the .IF block.
        ;; --------------------------------
        IFIDN $sw_state$, <if>
          poptext $end_sw$                  ;; Because there could have been an intervening
          pushtext $end_sw$                 ;; Switch/Case we need to recover the correct
          jmp   $end_sw$                    ;; exit label for this Switch/Case.
          .ENDIF
        ENDIF
        ;; --------------------------------
        ;; Start a new .IF block and update the state global.

        ;; *******************************************
        .if rv(Cmpi,$test_val$,chr$(quoted_text)) == 0
        ;; *******************************************

        $sw_state$ equ <if>
    ENDM

    elsei$ MACRO
        IFIDN $sw_state$, <if>              ;; If following a case$, emit a jump to the exit
          poptext $end_sw$                  ;; label for this Select/Case and terminate the .IF
          pushtext $end_sw$                 ;; block. The jump is necessary, whenever the case
          jmp   $end_sw$                    ;; for the .IF block being terminated is true, to
          .ENDIF                            ;; bypass the else statements that follow.
          $sw_state$ equ <>                 ;; The state global must be updated to stop the
        ENDIF                               ;; endsw$ from terminatinmg the .IF block.
    ENDM

    endswi$ MACRO
        IFIDN $sw_state$, <if>              ;; If following a case$, terminate the .IF block.
          .ENDIF
        ENDIF

        poptext $end_sw$                    ;; Remove the exit label from the stack.

      $end_sw$:

        poptext $end_sw$                    ;; Recover gobals for previous Switch/Case.
        poptext $sw_state$
        poptext $test_val$
    ENDM

; 

; ====================================

    tstiti    PROTO :DWORD
    tstits    PROTO :DWORD
    tstnested PROTO :DWORD
    Cmpi      PROTO :DWORD,:DWORD

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    mov   eax, 123h
    switchi$ chr$("abc")
      casei$ "A"
        mov   eax, 0
      casei$ "AB"
        mov   eax, 1
      casei$ "ABC"
        mov   eax, 2
      elsei$
        mov   eax, 3
    endswi$
    mov   eax, 321h

    fn tstiti,".e"
    fn tstiti,".el"
    fn tstiti,".els"
    fn tstiti,".else"
    fn tstiti,".ElseIf"
    fn tstiti,".endIF"
    fn tstiti,".if"

    print chr$(13,10),"i",13,10
    fn tstiti,".If"
    fn tstiti,".Else"
    fn tstiti,".Elseif"
    fn tstiti,".Endif"

    print chr$(13,10),"s",13,10
    fn tstits,".If"
    fn tstits,".Else"
    fn tstits,".Elseif"
    fn tstits,".Endif"

    print chr$(13,10),"isis",13,10
    fn tstiti,".If"
    fn tstits,".Else"
    fn tstiti,".Elseif"
    fn tstits,".Endif"

    print chr$(13,10),"nested1",13,10
    fn tstnested,".If"
    fn tstnested,".Else"
    fn tstnested,".Elseif"
    fn tstnested,".Endif"

    print chr$(13,10),"nested2",13,10
    fn tstnested,".if"
    fn tstnested,".else"
    fn tstnested,".elseif"
    fn tstnested,".endif"

    ret

main endp

; 

tstiti proc src:DWORD

    switchi$ src
      casei$ ".if"
        print ".IF selected",13,10
      casei$ ".elseif"
        print ".ELSEIF selected",13,10
      casei$ ".else"
        print ".ELSE selected",13,10
      casei$ ".endif"
        print ".ENDIF selected",13,10
      elsei$
        print "Unknow option selected",13,10
    endswi$
  
    ret

tstiti endp

tstits proc src:DWORD

    switch$ src
      case$ ".if"
        print ".IF selected",13,10
      case$ ".elseif"
        print ".ELSEIF selected",13,10
      case$ ".else"
        print ".ELSE selected",13,10
      case$ ".endif"
        print ".ENDIF selected",13,10
      else$
        print "Unknow option selected",13,10
    endsw$  
    ret

tstits endp

tstnested proc src:DWORD
    switchi$ src
      casei$ ".if"
        print ".IF selected",13,10
        switch$ src
          case$ ".if"
            print ".IF selected",13,10
            switchi$ src
              casei$ ".if"
                print ".IF selected",13,10
              elsei$
                print "Unknow option selected",13,10
             endswi$          
          else$
            print "Unknow option selected",13,10
        endsw$
      casei$ ".elseif"
        print ".ELSEIF selected",13,10
        switch$ src
          case$ ".elseif"
            print ".ELSEIF selected",13,10
          else$
            print "Unknow option selected",13,10
        endsw$
      casei$ ".else"
        print ".ELSE selected",13,10
        switch$ src
          case$ ".else"
            print ".ELSE selected",13,10
          else$
            print "Unknow option selected",13,10
        endsw$
      casei$ ".endif"
        print ".ENDIF selected",13,10
        switch$ src
          case$ ".endif"
            print ".ENDIF selected",13,10
          else$
            print "Unknow option selected",13,10
        endsw$
      elsei$
        print "Unknow option selected",13,10
    endswi$  
    ret
tstnested endp

; 

    .data
    align 16
      Cmpi_tbl \
      db   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
      db  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
      db  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47
      db  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
      db  64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95
      db  96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127
      db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
      db 144,145,146,147,148,149,150,151,152,153,154,155,156,156,158,159
      db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,173,175
      db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
      db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
      db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
      db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
      db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255

    .code

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

Cmpi proc src:DWORD,dst:DWORD

    push ebx
    push esi
    push edi

    mov esi, [esp+16]               ; src
    mov edi, [esp+20]               ; dst
    sub eax, eax                    ; zero eax as index

  align 4
  @@:
    movzx edx, BYTE PTR [esi+eax]
    movzx ebx, BYTE PTR [edi+eax]
    movzx ecx, BYTE PTR [edx+Cmpi_tbl]
    add eax, 1
    cmp cl, [ebx+Cmpi_tbl]
    jne quit                        ; exit on 1st mismatch with
    test cl, cl                     ; non zero value in EAX
    jnz @B

    sub eax, eax                    ; set EAX to ZERO on match

  quit:
    pop edi
    pop esi
    pop ebx

    ret 8

Cmpi endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

end start

    $test_val_i$ equ <>
    $end_sw_i$ equ <>
    $sw_state_i$ equ <>
    _sw_cnt_i = 0

    switchi$ MACRO lpstring:REQ
        pushtext $test_val_i$                   ;; Preserve globals for previous Switch/Case.
        pushtext $sw_state_i$
        pushtext $end_sw_i$

        $test_val_i$ equ <lpstring>               ;; Copy string address for this Select/Case
                                                  ;; to global so case$ can access it.             
        $sw_state_i$ equ <>                       ;; Set state global to starting value.
        _sw_cnt_i = _sw_cnt_i + 1                 ;; Generate a unique exit label for this
        $end_sw_i$ CATSTR <end_sw_i>, %_sw_cnt_i  ;; Select/Case and preserve it.
        pushtext $end_swi$
    ENDM

    casei$ MACRO quoted_text:REQ
        ;; The case statements will be any statements between the case$ and the following case$,
        ;; else$, or endsw$.
        ;;
        ;; If this is a following case$, emit a jump to the exit label for this Select/Case and
        ;; terminate the .IF block.
        ;; --------------------------------
        IFIDN $sw_state_i$, <if>
          poptext $end_sw_i$                      ;; Because there could have been an intervening
          pushtext $end_sw_i$                     ;; Switch/Case we need to recover the correct
          jmp   $end_sw_i$                        ;; exit label for this Switch/Case.
          .ENDIF
        ENDIF
        ;; --------------------------------
        ;; Start a new .IF block and update the state global.

        ;; *******************************************
        .if rv(Cmpi,$test_val_i$,chr$(quoted_text)) == 0
        ;; *******************************************

        $sw_state_i$ equ <if>
    ENDM

    elsei$ MACRO
        IFIDN $sw_state_i$, <if>            ;; If following a case$, emit a jump to the exit
          poptext $end_sw_i$                ;; label for this Select/Case and terminate the .IF
          pushtext $end_sw_i$               ;; block. The jump is necessary, whenever the case
          jmp   $end_sw_i$                  ;; for the .IF block being terminated is true, to
          .ENDIF                            ;; bypass the else statements that follow.
          $sw_state_i$ equ <>               ;; The state global must be updated to stop the
        ENDIF                               ;; endsw$ from terminatinmg the .IF block.
    ENDM

    endswi$ MACRO
        IFIDN $sw_state_i$, <if>            ;; If following a case$, terminate the .IF block.
          .ENDIF
        ENDIF

        poptext $end_sw_i$                  ;; Remove the exit label from the stack.

      $end_sw_i$:

        poptext $end_sw_i$                  ;; Recover gobals for previous Switch/Case.
        poptext $sw_state_i$
        poptext $test_val_i$
    ENDM



















